##
##
## Simple DIRAC buildup configuration file for the codefresh.io CI service 
## .. reads private gitlab repo of Miro Ilias
## .. public docker image from https://hub.docker.com/r/miroilias/docker_repo/builds/
##
##
## NOTE: free pricing plan has limitation to 30 minutes 
##       within this limit DIRAC sometimes does not even compile.
##

version: '1.0'
steps:
  system_info:
    title: print system info
    image: miroilias/docker_repo
    commands:
      - lscpu
      - echo nproc=$(nproc)
      - pwd
      - df -h
      - free -g -h
      - cmake --version
      - python -V
      - mpif90 --version
      - mpirun --version

  dirac_build:
    title: own build of DIRAC
    image: miroilias/docker_repo
    working_directory: ${{main_clone}}
    environment:
      - DIRAC_MPI_COMMAND=mpirun -np 2
      - CTEST_PROJECT_NAME=DIRAC
      - TEST_N_PROC=$(expr $(cat /proc/cpuinfo | grep processor | wc -l) / 2)
    when:
      branch:
        only: [ master ]
    commands:
      - /bin/rm -rf build
      - git submodule update --init --recursive
      - python ./setup --fc=mpif90 --cc=mpicc --cxx=mpicxx --int64 --mpi --cmake-options="-D BUILDNAME='gnu-mpich-i8-codefreshCI' -D DART_TESTING_TIMEOUT=99999 -D ENABLE_UNIT_TESTS=ON -D ENABLE_BASIS_SETS_CHECK=OFF" --type=debug build
      - cd build
      - ctest -D ExperimentalConfigure
      - ctest -j $(nproc) -D ExperimentalBuild
      - ldd dirac.x
      - echo "DIRAC_MPI_COMMAD=$DIRAC_MPI_COMMAND"
      - echo "TEST_N_PROC=$TEST_N_PROC"
# if some tests fail build/ctest can continue because of: || true
  #   - ctest -j $TEST_N_PROC  -D ExperimentalTest -L short || true
      - ctest -j $TEST_N_PROC  -V -D ExperimentalTest -R cosci || true
      - ctest -D ExperimentalSubmit

